;DVZ 2010
;  
; PortB   
;7-   (  -   )
;6- 
;5- 
;4- 
;3- OC1A 
;2- 
;1- 
;0- 
; 0 - 44100
; 1 - 36000   OC1A
;   -  -   PCINT 0,1,2,4,5,6,7 ()

;  7.372800 
; Fuses
; BOD2=0 BOD1=0 BOD0=1                  (BOD 110 lavel=1v8)
; SUT1=0 SUT0=1           			    (SUT= 10)
; CKSEL3=0 CKSEL2=0 CKSEL1=1 CKSEL0=0   (CKSEL=1101 -   8 )



.include "tiny2313def.inc"
 

;R0
;R1


.def PrevDT		=R13
.def EnPack		=R14
.def EnStar		=R15
.def temp0 		=R16 ;temporary register for Int
.def KeyCode	=R17	;
.def Polarity   =R18 ;  0  1
.def Cycle_I	=R19    
.def Cycle_J	=R20    
.def Cycle_K	=R21    
.def PacSz		=R21 
.def BT	 		=R22
.def SampleCnt  =R23
.def temp1      =R24 ;temporary register for Int

;R25 *
;R26 -XL
;R27 -XH
;R28 -YL *
;R29 -YH *
;R30 -ZL *
;R31 -ZH *
   
    
.dseg
.org 0x60
RX_comm:	.byte 1
RX_block:	.byte 1
RX_data:	.byte 32	

.cseg
.org 0	
 rjmp RESET    ; Reset 
 rjmp nul_ret    ; Interrupt0
  rjmp nul_ret ; Interrupt1 
  rjmp nul_ret ; Timer1 Capture 
  rjmp nul_ret ; Timer1 CompareA 
 rjmp timer1   ; Timer1 Overflow 
 rjmp timer0   ; Timer0 Overflow 
  rjmp RX_PC ; USART0 RX Complete Handler
  rjmp nul_ret ; USART0,UDR Empty Handler
  rjmp nul_ret ; USART0 TX Complete Handler
  rjmp nul_ret ; Analog Comparator Handler
 rjmp nul_ret   ; Pin Change Interrupt
  rjmp nul_ret ; Timer1 Compare B Handler
  rjmp nul_ret ; Timer0 Compare A Handler
  rjmp nul_ret ; Timer0 Compare B Handler
  rjmp nul_ret ; USI Start Handler
  rjmp nul_ret ; USI Overflow Handler
  rjmp nul_ret ; EEPROM Ready Handler
  rjmp nul_ret ; Watchdog Overflow Handler	
	
;.org	0x020
nul_ret:
 	reti

timer1:
	ldi temp1,1
	reti

;44100
timer0:
	in	temp0,SREG	
	nop
	nop
    ldi temp1,100			;(255-167);101
	out TCNT0,temp1	  	;reset counter
    dec SampleCnt
	out	SREG,temp0
	reti

; UART
RX_PC:
	in		temp0,SREG	
	push	temp0	
	push	r30
	push	r31
	in		temp0,UDR
	cpi		temp0,'*'
	brne	SkipStar
	clr		PacSz
	mov		EnStar,temp0	;   -     
SkipStar:
	cpi		temp0,13
	brne	SkipPac
	ldi		temp0,1			; 
	mov		EnPack,temp0
	rjmp	endPC
SkipPac:
	;  
	cpi		PacSz,1
	brne	SkipComm
	sts		RX_comm,temp0	; 
SkipComm:
	cpi		PacSz,71
	brge	endPC
	cpi		PacSz,2
	brlo	SkipStore
	sbrs	PacSz,0
	rjmp	SkipStore	;
	mov		r31,PrevDT
	cpi		r31,58
	brlo	skip8
	subi	r31,7
skip8:
	andi	r31,15
	swap	r31
	cpi		temp0,58
	brlo	skip9
	subi	temp0,7
skip9:
	andi	temp0,15
	or		temp0,r31

	mov		r30,PacSz
	subi	r30,2		;PacSz-2
	clc	
	ror		r30			;(PacSz-2)/2
	ldi		r31, low(RX_block)  ; RX_block+((PacSz-2)/2)
	add		r30,r31
	clr		r31
	st		Z,temp0

SkipStore:
	inc		PacSz
	mov 	PrevDT,temp0
endPC:
	pop		r31
	pop		r30
	pop		temp0
	out		SREG,temp0
	reti

 
RESET: 	
	cli
	in		r29,MCUSR		; 
	clr     r30
	OUT  	EECR,R30
	out 	MCUSR,r30		;  
	ldi 	r30,RAMEND
	out 	SPL,r30
    LDI  	R30,LOW(0x80)		;Crystal Oscillator division factor: 1
	STS  	CLKPR,R30
	CLR  	R30					;CLKPR=0x00;
	STS  	CLKPR,R30

	CLR  	R30 		
	out 	DDRB,r30    ;B   7in 6in 5in 4in 3in 2in 1in 0in
	ldi 	r30,0xf7	; 7 6 5 4 2 1 0
	out	    PORTB,r30

	CLR  	R30
	out		DDRA,r30
	out		PORTA,r30  
	out		DDRD,r30
	out		PORTD,r30 
	 
    call 	StopTimers

	;call 	StopUART	
	call	StartUart
	ldi		r30,0x72	;'r'
	call 	OutUartR30	

    clr 	r30	
	out		GIMSK,r30         ;PCInt 
	out		MCUCR,r30

	ldi 	r30,0xf7		  ;PCint mask
	out 	PCMSK,r30         ;   

	clr 	r30					
	out 	EIFR,r30
	nop
	
	;test

	;ldi 	KeyCode,3
	;rjmp	SkipSleeping
	;rjmp main

	andi    r29,1
	brbs    1,SkipLoader
;   PC   
;1 - 8
	ldi		r30,0x1
	out 	TCCR1B,r30		;top ffff fck/1  8ms
	clr 	r31
	out 	TCCR1A,r31		;timer 1 top ffff	
	out     TCNT1L,r31
	out     TCNT1H,r31
	ldi		r30,0x80
    out     TIMSK,r30		;timer1 OIE int - enable

;UART - 57600 8n1 RXie
	;call	StartUart
	sei

	ldi		r30,0x4c	;'L'
	call 	OutUartR30	

	nop
    clr 	temp1
	clr		EnStar
	clr		PacSz
	ldi		Cycle_I,64
LoopWaitLoader:
	ldi		r30,46		;
	call	OutUartR30
	call	WaitTemp1	
	tst		EnStar
	brne	BootLoader
	dec		Cycle_I
	brne	LoopWaitLoader
BootStop:
	;call	StopUart
	call	StopTimers
	rjmp	SkipLoader
BootLoader:
	call	WaitEnPack	;  
	; 
	lds		r30,RX_comm
	cpi		r30,0x53	;'S'
	breq	BootStop
	cpi		r30,0x52	;'R'
	brne	NotRead
	; 
	lds		r30,RX_block
	cpi		r30,28
	brge	BootLoader
    cpi		PacSz,4
	brlo	BootLoader
	call	R30BlockToUART
	rjmp	BootLoader
NotRead:
	cpi		r30,0x57	;'W'
	brne	BootLoader
	; 
	lds		r30,RX_block
	cpi		r30,28
	brge	BootLoader
	cpi		PacSz,68
	brlo	BootLoader
	call	R30BlockToFlash
	rjmp 	BootLoader

SkipLoader:
main:
    sei
;     
	call 	test_keyboard
	tst	    KeyCode ;   -  
	brbc	1,SkipSleeping

DoSleep:
	ldi		r30,0x53; 'S'
	call 	OutUartR30
	call	Del1ms
    call 	StopUART
	call	StopTimers

	ldi		r30,0x20
    out		GIMSK,r30	;PCint
	in 		r30,MCUCR
	cbr     r30,0x70
	sbr		r30,0x10
	out		MCUCR,r30	;PowerDown mode
	ori		r30,0x20
	out		MCUCR,r30	;PowerDown enable
	sei
	sleep
	in 		r30,MCUCR
	cbr		r30,0x20
	out 	MCUCR,r30	;WakeUp
	nop
	call	StartUart
	call	Del1ms
	call	Del1ms

	ldi		r30,0x55	;'U'
	call 	OutUartR30

	rjmp    main		;  
     
SkipSleeping:	
	mov		r30,KeyCode
	ori		r30,0x30
	call 	OutUartR30

;
	call	StartTimers
;test
    sbi		DDRB,3			;OC1A -  ()
	ldi		r30,low(PlayData*2)
	ldi		r31,high(PlayData*2)
	mov     r27,KeyCode
	dec     r27					;0-6
	clr		r26
	clc
	ror		r27
	ror		r26					;*128
	add		r30,r26
	adc		r31,r27				;PlayData + KeyCode*128
	ldi		Cycle_I,128
	clr 	Polarity			;  1
PlayPulseLoop:
	lpm		BT,Z
	adiw	r30,1
	inc		Polarity
	cpi	    BT,255
	breq	BreakPlay			;255 - 
	tst		BT
	breq	NextPulse			;  0 - 
PlayPulse:
	sbrc	Polarity,0		;  OC
	rjmp	is1
	clr 	r28
	out 	TCCR1A,r28		;force 0
	cbi		DDRB,3			;OC1A - 0 
	cbi		PORTB,3
is1:
	sbrs	Polarity,0
	rjmp	is0
	ldi 	r28,0x40
	out 	TCCR1A,r28		;force 0
	sbi		DDRB,3			;OC1A - 1 
is0:
; BT  44100
    mov 	SampleCnt,BT
WaitSamples:
	tst		SampleCnt
	brne	WaitSamples
NextPulse:    
	dec 	Cycle_I
	brne	PlayPulseLoop
BreakPlay:
	call	StopTimers

	; -  ,       
   ldi		Cycle_K,6	;150ms
Loop3:
	ldi		Cycle_J,241	; 25ms
 Loop2:
       ldi	Cycle_I,255
  Loop1:
   	   dec 	Cycle_I
	   brne	Loop1
     dec 	Cycle_J
   	 brne	Loop2
   	dec 	Cycle_K
   	brne	Loop3

	rjmp main

WaitTemp1:
	cpi	 temp1,1
	brne WaitTemp1	
	clr  temp1
	ret

WaitEnPack:
	tst	 EnPack
	brbs 1,WaitEnPack	
	clr  EnPack
	ret

del1ms:
	ldi		Cycle_J,25	; 1ms
 Loop10:
    ldi		Cycle_I,255
  Loop8:
    dec 	Cycle_I
    brne	Loop8
    dec 	Cycle_J
   	brne	Loop10
	ret

StopTimers:
	clr     r30				;timer0 - 44100  stopped
	cbi		DDRB,3
	cbi		PORTB,3
	out 	TCCR0A,r30    	;Normal Ports
	out     TCNT0,r30	  	;reset counter
	out 	TCCR0B,r30    	;fck/1
	out 	TCCR1A,r30	;timer 1
	out 	TCCR1B,r30
	out     TCCR1C,r30
	out     TCNT1L,r30     	
	out     TCNT1H,r30
    out     TIMSK,r30		;timer int - disabled
	ret

StartTimers:
	cbi		DDRB,3			;OC1A -  ()
    clr		r31
	ldi 	r30,88			;(255-167)
	out     TCNT0,r30	  	;reset counter
	out 	TCCR0A,r31    	;Normal Ports 
	ldi     r30,1			
	out 	TCCR0B,r30    	;fck/1 timer0 - 44100  start

	ldi 	r30,205
	out		ICR1L,r30
	out		ICR1H,r31		; top=205  36
	ldi		r30,102			;toggle point	35600
	out		OCR1AL,r30		;    1,  205 -  0
	out		OCR1AH,r31
	ldi 	r30,0x40		;c2	toggle on compare
	out 	TCCR1A,r30		;timer 1 FastPWM(set CompMaych reset Top) top ICR1	
	ldi		r30,0x09		;19	top OCR1A,ctc
	out 	TCCR1B,r30		;top ICR fastPWM fck/1
	out     TCCR1C,r31		;NoForceCompare

	out     TCNT1L,r31
	out     TCNT1H,r31

	ldi		r30,0x02
    out     TIMSK,r30		;timer0 OIE int - enable
	ret

;---------------  ---------------
test_keyboard:
	clr 	KeyCode
	sbis 	PINB,7
	ldi 	KeyCode,1
	sbis 	PINB,6
	ldi 	KeyCode,2
	sbis 	PINB,5
	ldi 	KeyCode,3
	sbis 	PINB,4
	ldi 	KeyCode,4
	sbis 	PINB,2
	ldi 	KeyCode,5
	sbis 	PINB,1
	ldi 	KeyCode,6
	sbis 	PINB,0
	ldi 	KeyCode,7
  	ret

OutUartR30:
	sbis 	UCSRA,UDRE
	rjmp 	OutUartR30
	out 	UDR,r30
	ret

OutUartR30HEXnibble:
	andi	r30,15
	ori		r30,0x30
	cpi	    r30,58
	brlo	skipadd
	subi	r30,249
skipadd:
	call	OutUartR30
	ret

OutUartR30HEX:
	push	r30
	swap	r30
	call	OutUartR30HEXnibble
	pop		r30
	call	OutUartR30HEXnibble
	ret

StartUart:
	sbi		DDRD,1		;TX out
	cbi		DDRD,0		;RX in
	sbi		PORTD,0		; 1
    ldi		r30,0x0e
	out 	ucsrc,r30	;8n2
	clr		r30
	out     UBRRH,r30
	ldi		r30,7
	out	    UBRRL,r30	;57600
	ldi		r30,0x98	
	out	    UCsRb,r30	;rxcie  rxen txen
	ret

StopUART:
	clr 	r30
	out     UCSRA,r30	;UART disabled
	out     UBRRH,r30
	out	    UBRRL,r30	
	out	    UCsRb,r30
	out 	ucsrc,r30
	ret	

BlockAdr:
    lds		r26,RX_block		;  N
	clr		r27
	rol		r26
	rol		r27
	rol		r26
	rol		r27
	rol		r26
	rol		r27
	rol		r26
	rol		r27
	rol		r26
	rol		r27
	andi	r26,0xE0	;N*32
	ldi		r30,low(PlayData*2)
	ldi		r31,high(PlayData*2)
	add		r30,r26
	adc		r31,r27
	ret

R30BlockToUART:
	ldi		r30,'?'
	call 	OutUartR30
	ldi		r30,'R'
	call 	OutUartR30
toRead:
	lds		r30,RX_block
	call 	OutUartR30HEX
	call	BlockAdr
	ldi		Cycle_I,32
LoopSend:
	lpm		r26,Z
	adiw	r30,1
	push	r30
	mov		r30,r26
	call 	OutUartR30HEX
	pop		r30
	dec		Cycle_I
	brne	LoopSend
vkps:
	ldi		r30,13
	call 	OutUartR30
	ldi		r30,10
	call 	OutUartR30
	ret

R30BlockToFlash:
	call	BlockAdr
	ldi		r26,3
	out		SPMCSR,r26	;erase block
	spm
	ldi		r28,low(RX_data)
	ldi		r29,high(RX_data)
	ldi		Cycle_I,16
	ldi		r26,1
	push	r30
	push	r31
LoopWR:
	ld		R0,Y+
	ld		R1,Y+
	out		SPMCSR,r26	;fill word in block
	spm		
	adiw	r30,2
	dec		Cycle_I
	brne	LoopWR
	pop		r31
	pop		r30
	ldi		r26,5
	out		SPMCSR,r26	;write block
	spm
	ldi		r30,'?'
	call 	OutUartR30
	ldi		r30,'W'
	call 	OutUartR30
	rjmp    toRead

	.org	0x240
PlayData:			;1 
	;ch-
	.db 	254,0,136,195,24,26,22,26,21,77,22,26,23,25,24,24,24,25,23,25,23,76,22,74,24,25,23,74,23,75,23,72,24,75,24,74,23,73,25,24,23,26,23,25,23,26,23,26,22,26,22,26,23,26,22,75,23,75,22,74,24,74,24,74,23,73,25,72,24,255

	.org	0x280	;2 
	;PIP
	.db 	254,0,135,195,22,27,23,25,23,75,24,24,23,26,23,25,23,26,23,25,23,74,24,74,22,27,23,73,24,73,24,74,23,76,23,72,25,25,23,25,23,26,23,25,23,25,23,74,23,76,23,25,23,74,24,73,23,74,24,73,24,75,24,24,23,26,23,74,23,255

	.org	0x2C0	;3
	;vol+
	.db 	254,0,136,195,22,28,21,27,23,74,24,24,23,26,23,25,23,26,23,24,23,75,23,75,23,26,23,73,24,73,24,73,24,75,24,72,24,26,23,73,24,27,22,24,24,25,24,24,23,27,21,27,23,75,23,24,24,74,23,74,23,76,23,72,24,74,24,73,24,255

	.org	0x300	;4
	;vol-	
	.db 	254,0,136,195,23,27,21,27,21,76,24,24,23,26,23,25,23,26,23,24,23,75,24,74,23,26,23,73,24,74,24,73,23,76,23,72,25,73,24,73,24,26,23,24,24,26,24,24,22,27,23,25,22,27,22,25,24,74,23,74,23,76,23,73,23,76,22,74,23,255

	.org	0x340	;5
	;ch+
    .db 	254,0,136,195,23,27,22,26,23,75,23,25,23,26,23,24,24,25,24,24,22,77,22,74,24,25,22,75,23,75,23,74,23,74,24,74,23,26,23,24,24,25,24,24,23,26,23,25,23,27,22,24,23,76,24,73,23,75,23,73,24,75,23,73,24,73,25,72,24,255

	.org	0x380	;6
	;menu-menu
	.db 	195,0,195,195,22,26,24,24,23,76,23,25,23,26,23,25,22,26,24,24,23,75,23,75,23,26,23,73,23,76,22,73,24,75,24,72,24,75,25,76,25,25,25,75,25,76,25,75,25,76,25,75,25,25,26,25,25,75,25,25,25,26,25,25,25,25,25,25,25,255

	.org	0x3C0	;7  
	;OK-OK
	.db 	195,0,195,195,23,23,23,23,23,74,23,23,24,23,23,23,23,23,23,23,23,74,23,74,23,23,22,74,23,74,23,71,26,71,23,72,26,72,26,73,26,73,26,73,26,73,26,73,26,73,26,73,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,24,255




