;* File Name		:"tiny2313def.inc"
;* Title		:Register/Bit Definitions for the ATtiny2313
;* Target MCU		:ATtiny2313

;.device ATtiny2313

;***** I/O Register Definitions
.equ	SREG	=$3f
.equ	SPL	=$3d
.equ	OCR0B	=$3c
.equ	GIMSK	=$3b
.equ	EIFR	=$3a
.equ	TIMSK	=$39
.equ	TIFR	=$38
.equ	spmcsr	=$37
.equ	ocr0a	=$36
.equ	MCUCR	=$35
.equ	mcusr	=$34
.equ	TCCR0b	=$33
.equ	TCNT0	=$32
.equ	osccal	=$31
.equ	tccr0a	=$30
.equ	TCCR1A	=$2f
.equ	TCCR1B	=$2e
.equ	TCNT1H	=$2d
.equ	TCNT1L	=$2c
.equ	OCR1AH	=$2b
.equ	OCR1AL	=$2a
.equ	ocr1bh	=$29
.equ	ocr1bl	=$28
.equ	clkpr	=$26
.equ	ICR1H	=$25
.equ	ICR1L	=$24
.equ	gtccr	=$23
.equ	tccr1c	=$22
.equ	WDTCsR	=$21
.equ	pcmsk	=$20
.equ	EEAR	=$1e
.equ	EEARL	=$1e
.equ	EEDR	=$1d
.equ	EECR	=$1c
.equ	porta	=$1b
.equ	ddra	=$1a
.equ	pina	=$19
.equ	PORTB	=$18
.equ	DDRB	=$17
.equ	PINB	=$16
.equ	gpior2	=$15
.equ	gpior1	=$14
.equ	gpiord	=$13
.equ	PORTD	=$12
.equ	DDRD	=$11
.equ	PIND	=$10
.equ	usidr	=$0f
.equ	usisr	=$0e
.equ	usicr	=$0d
.equ	UDR	=$0c
.equ	UcSRa	=$0b
.equ	UCsRb	=$0a
.equ	UBRRL	=$09
.equ	ACSR	=$08
.equ	ucsrc	=$03
.equ	ubrrh	=$02

;***** Bit Definitions
.equ	SP7	=7
.equ	SP6	=6
.equ	SP5	=5
.equ	SP4	=4
.equ	SP3	=3
.equ	SP2	=2
.equ	SP1	=1
.equ	SP0	=0

.equ	INT1	=7
.equ	INT0	=6

.equ	INTF1	=7
.equ	INTF0	=6

.equ	TOIE1	=7
.equ	OCIE1A	=6
.equ	OCIE1b	=5
.equ	TICIE1	=3
.equ	ocie0b	=2
.equ	TOIE0	=1
.equ	ocie0a	=0

.equ	TOV1	=7
.equ	OCF1A	=6
.equ	ocf1b	=5
.equ	ICF1	=3
.equ	ocf0b	=2
.equ	TOV0	=1
.equ	ocf0a	=0

.equ	pud	=7
.equ	sm1	=6
.equ	SE	=5
.equ	SM	=4
.equ	ISC11	=3
.equ	ISC10	=2
.equ	ISC01	=1
.equ	ISC00	=0


.equ	wdrf	=3
.equ	borf	=2
.equ	extrf	=1
.equ	pofr	=0

.equ	foc0a	=7
.equ	foc0b	=6
.equ	wgm02	=3
.equ	CS02	=2
.equ	CS01	=1
.equ	CS00	=0

.equ	cal6	=6
.equ	cal5	=5
.equ	cal4	=4
.equ	cal3	=3
.equ	cal2	=2
.equ	cal1	=1
.equ	col0	=0

.equ	COM0A1	=7
.equ	COM0A0	=6
.equ	com0b1	=5
.equ	com0b0	=4
.equ	wgm01	=1
.equ	wgm00	=0

.equ	COM1A1	=7
.equ	COM1A0	=6
.equ	com1b1	=5
.equ	com1b0	=4
.equ	wgm11	=1
.equ	wgm10	=0

.equ	ICNC1	=7
.equ	ICES1	=6
.equ	wgm13	=4
.equ	wgm12	=3
.equ	CS12	=2
.equ	CS11	=1
.equ	CS10	=0

.equ	clkpce	=7
.equ	clkpcs3	=3
.equ	clkpcs2	=2
.equ	clkpcs1	=1
.equ	clkpcs0	=0

.equ	pcr10	=0

.equ	foc1a	=7
.equ	foc1b	=6

.equ	wdif	=7
.equ	wdie	=6
.equ	wdp3	=5
.equ	WDcE	=4
.equ	WDE	=3
.equ	WDP2	=2
.equ	WDP1	=1
.equ	WDP0	=0

.equ	pcint7	=7
.equ	pcint6	=6
.equ	pcint5	=5
.equ	pcint4	=4
.equ	pcint3	=3
.equ	pcint2	=2
.equ	pcint1	=1
.equ	pcint0	=0

.equ	eepm1	=5
.equ	eepm0	=4
.equ	eerie	=3
.equ	EEMpE	=2
.equ	EEpE	=1
.equ	EERE	=0

.equ	Pa2	=2
.equ	Pa1	=1
.equ	Pa0	=0

.equ	DDa2	=2
.equ	DDa1	=1
.equ	DDa0	=0

.equ	PINa2	=2
.equ	PINa1	=1
.equ	PINa0	=0

.equ	PB7	=7
.equ	PB6	=6
.equ	PB5	=5
.equ	PB4	=4
.equ	PB3	=3
.equ	PB2	=2
.equ	PB1	=1
.equ	PB0	=0

.equ	DDB7	=7
.equ	DDB6	=6
.equ	DDB5	=5
.equ	DDB4	=4
.equ	DDB3	=3
.equ	DDB2	=2
.equ	DDB1	=1
.equ	DDB0	=0

.equ	PINB7	=7
.equ	PINB6	=6
.equ	PINB5	=5
.equ	PINB4	=4
.equ	PINB3	=3
.equ	PINB2	=2
.equ	PINB1	=1
.equ	PINB0	=0

.equ	PD6	=6
.equ	PD5	=5
.equ	PD4	=4
.equ	PD3	=3
.equ	PD2	=2
.equ	PD1	=1
.equ	PD0	=0

.equ	DDD6	=6
.equ	DDD5	=5
.equ	DDD4	=4
.equ	DDD3	=3
.equ	DDD2	=2
.equ	DDD1	=1
.equ	DDD0	=0

.equ	PIND6	=6
.equ	PIND5	=5
.equ	PIND4	=4
.equ	PIND3	=3
.equ	PIND2	=2
.equ	PIND1	=1
.equ	PIND0	=0

.equ	usisf	=7
.equ	usioif	=6
.equ	usipf	=5
.equ	usidf	=4
.equ	usicnt3	=3
.equ	usicnt2	=2
.equ	usicnt1	=1
.equ	usicnt0	=0

.equ	usisie	=7
.equ	usioie	=6
.equ	usiwm1	=5
.equ	usiwm0	=4
.equ	usics1	=3
.equ	usics0	=2
.equ	usiclk	=1
.equ	usitc	=0

.equ	RXC	=7
.equ	TXC	=6
.equ	UDRE	=5
.equ	FE	=4
.equ	dOR	=3
.equ	upe	=2
.equ	u2x	=1
.equ	mpcm	=0

.equ	RXCIE	=7
.equ	TXCIE	=6
.equ	UDRIE	=5
.equ	RXEN	=4
.equ	TXEN	=3
.equ	ucsz2	=2
.equ	RXB8	=1
.equ	TXB8	=0

.equ	ACD	=7
.equ	acbg	=6
.equ	ACO	=5
.equ	ACI	=4
.equ	ACIE	=3
.equ	ACIC	=2
.equ	ACIS1	=1
.equ	ACIS0	=0

.equ	umsel	=6
.equ	upm1	=5
.equ	upm0	=4
.equ	usbs	=3
.equ	ucsz1	=2
.equ	ucsz0	=1
.equ	ucpol	=0

.equ	ain1d	=1
.equ	ain0d	=0

.def	XL	=r26
.def	XH	=r27
.def	YL	=r28
.def	YH	=r29
.def	ZL	=r30
.def	ZH	=r31

.equ    RAMEND  =$DF    ;Last On-Chip SRAM Location
.equ	XRAMEND =$DF
.equ	E2END	=$7F
.equ	FLASHEND=$3FF

.equ 	RESETaddr=$000 		; Reset Handler
.equ 	INT0addr=$0001		; External Interrupt0 Handler
.equ 	INT1addr=$0002	 	; External Interrupt1 Handler
.equ 	ICP1addr=$0003 	; Timer1 Capture Handler
.equ 	OC1addr=$0004 	; Timer1 CompareA Handler
.equ 	OVF1addr=$0005 	; Timer1 Overflow Handler
.equ 	OVF0addr=$0006 	; Timer0 Overflow Handler
.equ 	URXCaddr=$0007 	; USART0 RX Complete Handler
.equ 	UDREaddr=$0008	; USART0,UDR Empty Handler
.equ 	UTXCaddr=$0009 	; USART0 TX Complete Handler
.equ 	ACIaddr =$000a 	; Analog Comparator Handler
.equ 	PCINTaddr=$000b 		; Pin Change Interrupt
.equ 	TIMER1_COMPBaddr=$000c 	; Timer1 Compare B Handler
.equ 	TIMER0_COMPAaddr=$000d 	; Timer0 Compare A Handler
.equ 	TIMER0_COMPBaddr=$000e 	; Timer0 Compare B Handler
.equ 	USI_STARTaddr=$000f 	; USI Start Handler
.equ 	USI_OVERFLOWaddr=$0010 	; USI Overflow Handler
.equ 	EE_READYaddr=$0011 	; EEPROM Ready Handler
.equ 	WDT_OVERFLOWaddr=$0012

